<?php

/*
 *  PUMA/BibSonomy CSL (ext_bibsonomy_csl) is a TYPO3 extension which
 *  enables users to render publication lists from PUMA or BibSonomy in
 *  various styles.
 *
 *  Copyright notice
 *  (c) 2015 Sebastian Böttger <seboettg@gmail.com>
 *
 *  HothoData GmbH (http://www.academic-puma.de)
 *  Knowledge and Data Engineering Group (University of Kassel)
 *
 *  All rights reserved
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\ExtBibsonomyCsl\Domain\Exception;

/**
 * InvalidStylesheetException
 *
 * @author Sebastian Böttger
 */
class AuthExistException extends AbstractException
{

    protected $hostUserName;

    protected $hostAddress;

    protected $enableOAuth;

    /**
     * @param string $message
     * @param int $code
     * @param null $previous
     * @param string $hostUserName
     * @param int $hostAddress
     * @param boolean $enableOAuth
     */
    public function __construct($message, $code, $previous, $hostUserName, $hostAddress, $enableOAuth)
    {

        parent::__construct($message, $code, $previous);
        $this->hostUserName = $hostUserName;
        $this->hostAddress  = $hostAddress;
        $this->enableOAuth  = $enableOAuth;
        $this->debug();
    }

    /**
     * @return string
     */
    public function getHostUserName()
    {

        return $this->hostUserName;
    }

    /**
     * @return int
     */
    public function getHostAddress()
    {

        return $this->hostAddress;
    }

    /**
     * @return boolean
     */
    public function isEnableOAuth()
    {

        return $this->enableOAuth;
    }

}
