function toggleTrace() {
    if (document.getElementById('academicpuma_bibsonomyerror').style.display === 'block') {
        document.getElementById('academicpuma_bibsonomyerror').style.display = 'none';
    } else {
        document.getElementById('academicpuma_bibsonomyerror').style.display = 'block';
    }
}

function bindEvent(element, type, handler) {
    if (element.addEventListener) {
        element.addEventListener(type, handler, false);
    } else {
        element.attachEvent('on' + type, handler);
    }
}

function loadurl(dest, objnev) {

    try {
        xmlhttp = window.XMLHttpRequest ? new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");
    } catch (e) {
        console.log(e);
    }
    xmlhttp.onreadystatechange = function () {
        triggered(objnev);
    };

    xmlhttp.open("GET", dest);
    xmlhttp.send(null);
}

function triggered(objnev) {

    if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200)) {
        document.getElementById(objnev).innerHTML = xmlhttp.responseText;
    }
}

function escapeBibtex() {
    var items = document.getElementsByClassName('tx-extbibsonomycsl-pub-bibtex-content');
    for (var i = 0; i < items.length; i++) {
        var item = items[i];
        item.value = item.value.replace(/%/g, '\\%');
        item.value = item.value.replace(/~/g, '\\~');
        item.value = item.value.replace(/&/g, '\\&');
        item.value = item.value.replace(/#/g, '\\#');
        item.value = item.value.replace(/_/g, '\\_');
        // Remove backslashes of double escaped characters, till a better regex is found
        item.value = item.value.replace(/\\\\/g, '\\');
    }
}

function linkDisplay() {
    var items = document.getElementsByClassName('tx-extbibsonomycsl-bib-link');

    for (i = 0; i < items.length; i++) {

        var item = items[i];

        item.addEventListener('click', function (event) {

            event = event || window.event;

            if (this.className.indexOf('bibtex') > -1 ||
                this.className.indexOf('endnote') > -1 ||
                this.className.indexOf('abstract') > -1) {

                event.preventDefault();
            }

            // get href
            var href = this.childNodes[1].getAttribute("href");

            //get area (abs|bib)
            var area = this.childNodes[1].getAttribute("rel").substr(0, 3);

            //get id
            var id = this.childNodes[1].getAttribute("rel").substr(4);

            // toggle
            var show = area + '-' + id; // element id to show

            var hide = new Array();

            //hide bibtex or abstract?
            if (area === 'bib') {
                hide[0] = 'abs' + '-' + id;
                hide[1] = 'end' + '-' + id;
            } else if (area === 'abs') {
                hide[0] = 'bib' + '-' + id;
                hide[1] = 'end' + '-' + id;
            } else if (area === 'end') {
                hide[0] = 'abs' + '-' + id;
                hide[1] = 'bib' + '-' + id;
            }

            //element to show
            var showVar = document.getElementById(show);

            if (showVar) {

                // hide the other one
                if (document.getElementById(hide[0])) {
                    document.getElementById(hide[0]).style.display = "none";
                }
                if (document.getElementById(hide[1])) {
                    document.getElementById(hide[1]).style.display = "none";
                }

                if (showVar.style.display === 'none') {
                    showVar.style.display = 'block';
                } else {
                    showVar.style.display = 'none';
                }
            }
            // if this container for link to bibtex
//            if (this.className.indexOf('bibtex') > -1 || this.className.indexOf('endnote') > -1) {
//
//                loadurl(href, area + "-" + id);
//            }

            return false;
        });
    }
}

window.addEventListener("load", function () {

    linkDisplay();
    escapeBibtex();
});