<?php

/*
 *  restclient-php is a full-featured REST client for PUMA and/or
 *  BibSonomy.
 *
 *  Copyright (C) 2015
 *
 *  Knowledge & Data Engineering Group,
 *  University of Kassel, Germany
 *  http://www.kde.cs.uni-kassel.de/
 *
 *  HothoData GmbH, Germany
 *  http://www.academic-puma.de
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\RestClient\Model;


use AcademicPuma\RestClient\Util\Collection\Comparable;

class Document implements ModelObject, Comparable {

    /**
     * @var string $filename
     */
    private $filename;

    /**
     * @var string $md5hash
     */
    private $md5hash;

    /**
     * @var string $href
     */
    private $href;

    /**
     * @var string $userName
     */
    private $userName;

    /**
     * @return string
     */
    public function getFilename() {
        return $this->filename;
    }

    /**
     * @param string $filename
     */
    public function setFilename($filename) {
        $this->filename = $filename;
    }

    /**
     * @return string
     */
    public function getMd5hash() {
        return $this->md5hash;
    }

    /**
     * @param string $md5hash
     */
    public function setMd5hash($md5hash) {
        $this->md5hash = $md5hash;
    }

    /**
     * @return string
     */
    public function getHref() {
        return $this->href;
    }

    /**
     * @param string $href
     */
    public function setHref($href) {
        $this->href = $href;
    }

    function getUserName() {
        return $this->userName;
    }

    function setUserName($userName) {
        $this->userName = $userName;
    }

    public function __toString() {
        return $this->filename;
    }

    public function compare(Comparable $b) {
        return strcmp($this->getFilename(), $b->getFilename());
    }

}