<?php

/*
 *  restclient-php is a full-featured REST client for PUMA and/or
 *  BibSonomy.
 *
 *  Copyright (C) 2015
 *
 *  Knowledge & Data Engineering Group,
 *  University of Kassel, Germany
 *  http://www.kde.cs.uni-kassel.de/
 *
 *  HothoData GmbH, Germany
 *  http://www.academic-puma.de
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\RestClient\Model;

use AcademicPuma\RestClient\Util\Collection\Comparable;

/**
 * Description of Group
 *
 * @author Sebastian Böttger <boettger@cs.uni-kassel.de>
 */
class Group implements ModelObject, Comparable {

    /**
     * @var string
     */
    private $name;

    /**
     *
     * @var string
     */
    private $description;

    /**
     *
     * @var string
     */
    private $href;

    /**
     *
     * @var string
     */
    private $realname;

    private $homepage;

    /**
     * @var Users
     */
    private $users;

    /**
     *
     */
    public function __construct() {
        $this->users = new Users();
    }
    /**
     * @return Users
     */
    public function getUsers() {

        return $this->users;
    }

    /**
     * @param Users $users
     */
    public function setUsers(Users $users) {

        $this->users = $users;
    }

    public function addUser(User $user) {
        $this->users->add($this->users->count(), $user);
    }

    public function getHomepage() {
        return $this->homepage;
    }

    public function setHomepage($homepage) {
        $this->homepage = $homepage;
    }

        public function getName() {
        return $this->name;
    }

    public function getDescription() {
        return $this->description;
    }

    public function getHref() {
        return $this->href;
    }

    public function setName($name) {
        $this->name = $name;
        return $this;
    }

    public function setDescription($description) {
        $this->description = $description;
        return $this;
    }

    public function setHref($href) {
        $this->href = $href;
        return $this;
    }

    public function getRealname() {
        return $this->realname;
    }

    public function setRealname($realname) {
        $this->realname = $realname;
        return $this;
    }

    public function __toString() {
        return $this->name;
    }

    public function compare(Comparable $b) {
        return strcmp($this->getName(), $b->getName());
    }
}
