<?php

/*
 *  restclient-php is a full-featured REST client for PUMA and/or
 *  BibSonomy.
 *
 *  Copyright (C) 2015
 *
 *  Knowledge & Data Engineering Group,
 *  University of Kassel, Germany
 *  http://www.kde.cs.uni-kassel.de/
 *
 *  HothoData GmbH, Germany
 *  http://www.academic-puma.de
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\RestClient\Model;

use AcademicPuma\RestClient\Util\Collection\Comparable;


/**
 * Description of User
 *
 * @author Sebastian Böttger <boettger@cs.uni-kassel.de>
 */
class User implements ModelObject, Comparable {
    
    /**
     *
     * @var string 
     */
    private $name;
    
    private $realname;
    
    private $email;
    
    private $homepage;
    
    private $groups;
    
    private $spammer;
    
    private $prediction;
    
    private $algorithm; 
    
    private $toClassify;
    /**
     *
     * @var string 
     */
    private $href;

    public function __construct() {
    }
    
    public function getRealname() {
        return $this->realname;
    }

    public function getEmail() {
        return $this->email;
    }

    public function getHomepage() {
        return $this->homepage;
    }

    public function setRealname($realname) {
        $this->realname = $realname;
        return $this;
    }

    public function setEmail($email) {
        $this->email = $email;
        return $this;
    }

    public function setHomepage($homepage) {
        $this->homepage = $homepage;
        return $this;
    }

    
    /**
     * 
     * @return string
     */
    public function getName() {
        return $this->name;
    }

    /**
     * 
     * @return string
     */
    public function getHref() {
        return $this->href;
    }

    /**
     *
     * @param string $name
     *
     * @return $this
     */
    public function setName($name) {
        $this->name = $name;
        return $this;
    }

    /**
     *
     * @param string $href
     *
     * @return $this
     */
    public function setHref($href) {
        $this->href = $href;
        return $this;
    }

    public function getGroups() {
        return $this->groups;
    }

    public function hasGroups() {
        return count($this->groups) > 0 ? true : false;
    }
    
    public function setGroups($groups) {
        $this->groups = $groups;
    }
    
    public function getSpammer() {
        return $this->spammer;
    }

    public function getPrediction() {
        return $this->prediction;
    }

    public function getAlgorithm() {
        return $this->algorithm;
    }

    public function getToClassify() {
        return $this->toClassify;
    }

    public function setSpammer($spammer) {
        $this->spammer = $spammer;
        return $this;
    }

    public function setPrediction($prediction) {
        $this->prediction = $prediction;
        return $this;
    }

    public function setAlgorithm($algorithm) {
        $this->algorithm = $algorithm;
        return $this;
    }

    public function setToClassify($toClassify) {
        $this->toClassify = $toClassify;
        return $this;
    }

    public function __toString() {
        return $this->name;
    }

    public function compare(Comparable $b) {
        return strcmp($this->getName(), $b->getName());
    }
}
