<?php

/*
 *  restclient-php is a full-featured REST client for PUMA and/or
 *  BibSonomy.
 *
 *  Copyright (C) 2015
 *
 *  Knowledge & Data Engineering Group,
 *  University of Kassel, Germany
 *  http://www.kde.cs.uni-kassel.de/
 *
 *  HothoData GmbH, Germany
 *  http://www.academic-puma.de
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\RestClient\Model;

use AcademicPuma\RestClient\Util\Collection\ArrayList;
use AcademicPuma\RestClient\Util\Collection;
use AcademicPuma\RestClient\Config;

/**
 * Description of Posts
 *
 * @author Sebastian Böttger <boettger@cs.uni-kassel.de>
 */
class Users extends ArrayList implements ModelObject {

    /**
     * @var int $start
     */
    private $start;

    /**
     * @var int $end
     */
    private $end;

    /**
     * @var string $next
     */
    private $next;

    /**
     * @return int
     */
    public function getStart() {
        return $this->start;
    }

    /**
     * @return int
     */
    public function getEnd() {
        return $this->end;
    }

    /**
     * @param int $start
     */
    public function setStart($start) {
        $this->start = $start;
    }

    /**
     * @param int $end
     */
    public function setEnd($end) {
        $this->end = $end;
    }

    /**
     * @return string
     */
    public function getNext() {

        return $this->next;
    }

    /**
     * @param string $next
     */
    public function setNext($next) {

        $this->next = $next;
    }


    /**
     * @return string
     */
    public function __toString() {

        return '['.implode(',', $this->toArray()).']';
    }

    /**
     * @param string $order sorting order (allowed values: asc|desc)
     *
     * @return $this
     */
    public function sort($order = Config\Sorting::ORDER_ASC) {

        $comparator = new Collection\Comparator($order);
        usort($this->array, [$comparator, "compare"]);
        return $this;
    }
}
