<?php

namespace AcademicPuma\RestClient\Queries\Delete;

use AcademicPuma\RestClient\Accessor\Accessor;
use AcademicPuma\RestClient\Queries;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:52:14.
 */
class DeletePostDocumentQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var DeletePostDocumentQuery
     */
    protected $deletePostDocumentQuery;

    private $filename = 'noise.png';
    private $postIntrahash = 'e645f73921b98b1c6b0e17fe617b74b2';

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {

        global $ACCESSOR_BASICAUTH;

        // Create post document to test if it can be deleted.
        $createPostDocumentQuery = new Queries\Post\CreatePostDocumentQuery(
                PROJECT_HOME.'/data/user_exports/'.$this->filename, $this->postIntrahash, TEST_USER_ID);

        $statusCode = $createPostDocumentQuery->execute($ACCESSOR_BASICAUTH->getClient())->getStatusCode();
        $this->assertEquals('201', $statusCode);
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

    }

    /**
     * @dataProvider executeProvider
     *
     * @param Accessor $accessor
     * @param string   $userName
     * @param string   $resourceHash
     * @param string   $fileName
     */
    public function testExecute(Accessor $accessor, $userName, $resourceHash, $fileName) {

        $this->deletePostDocumentQuery = new DeletePostDocumentQuery($userName, $resourceHash, $fileName);

        // Check statuscode.
        $statusCode = $this->deletePostDocumentQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, TEST_USER_ID, $this->postIntrahash, $this->filename),
          array($ACCESSOR_OAUTH, TEST_USER_ID, $this->postIntrahash, $this->filename)
        );
    }

}
