<?php

namespace AcademicPuma\RestClient\Queries\Get;

use \AcademicPuma\RestClient\Config;
use \AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:32.
 */
class GetConceptDetailsQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetConceptDetailsQuery
     */
    protected $getConceptDetailsQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

    }

    /**
     * @dataProvider executeProvider
     *
     * @throws \AcademicPuma\RestClient\Exceptions\UnsupportedOperationException
     */
    public function testExecute($accessor, $conceptName, $userName) {

        $this->getConceptDetailsQuery = new GetConceptDetailsQuery($conceptName, $userName);

        // Check status code.
        $statusCode = $this->getConceptDetailsQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);

        // Check type.
        $tag = $this->getConceptDetailsQuery->model();
        $this->assertTrue($tag instanceof Model\Tag);

        $subTags = $tag->getSubTags();
        $this->assertTrue(!empty($subTags));
        foreach ($subTags as $subTag) {
            $this->assertTrue($subTag instanceof Model\Tag);
        }

        // Is executed flag set?
        $this->assertTrue($this->getConceptDetailsQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, 'folksonomy', TEST_USER_ID),
          array($ACCESSOR_OAUTH, 'folksonomy', TEST_USER_ID)
        );
    }
}
