<?php

namespace AcademicPuma\RestClient\Queries\Get;

use AcademicPuma\RestClient\Config;
use AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:33.
 */
class GetConceptsQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetConceptsQuery
     */
    protected $getConceptsQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {

    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

    }

    /**
     * @dataProvider executeProvider
     */
    public function testExecute($accessor, $resourceType, $grouping, $groupingName, $regex, $tags, $status, $start, $end) {

        $this->getConceptsQuery = new GetConceptsQuery($resourceType, $grouping, $groupingName, $regex, $tags, $status,
                $start, $end);

        // Check status code.
        $statusCode = $this->getConceptsQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);


        // Check content.
        $expectedXML = '<tag name="folksonomy"';
        $responseBody = $this->getConceptsQuery->getBody();
        $this->assertContains($expectedXML, $responseBody);

        // Check type.
        $conceptTags = $this->getConceptsQuery->model();
        foreach ($conceptTags as $tag) {
            $this->assertTrue($tag instanceof Model\Tag );
        }

        // Is executed flag set?
        $this->assertTrue($this->getConceptsQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, Config\Resourcetype::BIBTEX, Config\RESTConfig::USERS_URL, TEST_USER_ID,
                NULL, [], NULL, NULL, NULL),
          array($ACCESSOR_OAUTH, Config\Resourcetype::BIBTEX, Config\RESTConfig::USERS_URL, TEST_USER_ID,
                NULL, [], NULL, NULL, NULL)
        );
    }
}
