<?php

namespace AcademicPuma\RestClient\Queries\Get;

use AcademicPuma\RestClient\Config;
use AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:33.
 */
class GetFriendsQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetFriendsQuery
     */
    protected $getFriendsQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

    }

    /**
     * @dataProvider executeProvider
     */
    public function testExcecute($accessor, $username, $relation, $start, $end) {

        $getFriendsQuery = new GetFriendsQuery($username, $relation, $start, $end);

        // Excecute and check status code.
        $statusCode = $getFriendsQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);

        // Check content.
        $body = $getFriendsQuery->getBody();

        if ($relation === Config\RESTConfig::INCOMING_ATTRIBUTE_VALUE_RELATION) {
            $this->assertContains('<user name="'.TEST_FRIEND_INCOMING.'"', $body);
        } else {
            $this->assertContains('<user name="'.TEST_FRIEND_OUTGOING.'"', $body);
        }

        // Check type.
        /**
         * @var Model\Users $users
         */
        $users = $getFriendsQuery->model();

        $this->assertTrue($users instanceof Model\Users);
        $this->assertTrue($users->count() >= 1);


        foreach($users as $user) {
            $this->assertTrue($user instanceof Model\User);
        }

        // Is executed flag set?
        $this->assertTrue($getFriendsQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, TEST_USER_ID, Config\RESTConfig::INCOMING_ATTRIBUTE_VALUE_RELATION, NULL, NULL),
          array($ACCESSOR_OAUTH, TEST_USER_ID, Config\RESTConfig::OUTGOING_ATTRIBUTE_VALUE_RELATION, NULL, NULL)
        );
    }
}
