<?php

namespace AcademicPuma\RestClient\Queries\Get;

use AcademicPuma\RestClient\Accessor\Accessor;
use AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:28.
 */
class GetGroupDetailsQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetGroupDetailsQuery
     */
    protected $getGroupDetailsQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
    }

    /**
     * @dataProvider executeProvider
     *
     * @param Accessor $accessor
     * @param          $groupName
     *
     * @throws \AcademicPuma\RestClient\Exceptions\UnsupportedOperationException
     */
    public function testExecute(Accessor $accessor, $groupName) {

        $this->getGroupDetailsQuery = new GetGroupDetailsQuery($groupName);

        // Check status code.
        $statusCode = $this->getGroupDetailsQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);

        // Check content.
        $body = $this->getGroupDetailsQuery->getBody();
        $this->assertContains('<group name="'.TEST_GROUP.'"', $body);

        // Check type.
        $group = $this->getGroupDetailsQuery->model();
        $this->assertTrue($group instanceof Model\Group);

        // Is executed flag set?
        $this->assertTrue($this->getGroupDetailsQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, TEST_GROUP),
          array($ACCESSOR_OAUTH, TEST_GROUP)
        );
    }
}
