<?php

namespace AcademicPuma\RestClient\Queries\Get;

use AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:32.
 */
class GetGroupListQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetGroupListQuery
     */
    protected $getGroupListQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
    }

    /**
     * @dataProvider executeProvider
     */
    public function testExecute($accessor, $start, $end) {

        $this->getGroupListQuery = new GetGroupListQuery($start, $end);

        // Check status code.
        $statusCode = $this->getGroupListQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);

        // Check content.
        $body = $this->getGroupListQuery->getBody();
        $this->assertContains('<group name="dlt-forschung"', $body);

        // Check type.
        $groups = $this->getGroupListQuery->model();
        $this->assertTrue($groups instanceof Model\Groups);

        foreach ($groups as $group) {
            $this->assertTrue($group instanceof Model\Group);
        }

        //$this->assertContains('<user name="sboettger"', $body);

        // Is executed flag set?
        $this->assertTrue($this->getGroupListQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, 0, 5),
          array($ACCESSOR_OAUTH, 0, 5)
        );
    }
}
