<?php

namespace AcademicPuma\RestClient\Queries\Get;

use AcademicPuma\RestClient\Model;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:46:29.
 */
class GetUserDetailsQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var GetUserDetailsQuery
     */
    protected $getUserDetailsQuery;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
    }

    /**
     * @dataProvider executeProvider
     */
    public function testExecute($accessor, $username) {

        $this->getUserDetailsQuery = new GetUserDetailsQuery($username);

        // Check status code.
        $statusCode = $this->getUserDetailsQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);

        // Check content.
        $body = $this->getUserDetailsQuery->getBody();
        $this->assertContains('<user name="'. TEST_USER_ID .'"', $body);

        // Check type.
        $user = $this->getUserDetailsQuery->model();
        $this->assertTrue($user instanceof Model\User);

        // Is executed flag set?
        $this->assertTrue($this->getUserDetailsQuery->isExecuted());
    }

        public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, TEST_USER_ID),
          array($ACCESSOR_OAUTH, TEST_USER_ID)
        );
    }
}
