<?php

namespace AcademicPuma\RestClient\Queries\Post;

use AcademicPuma\RestClient\Queries;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-06 at 11:48:56.
 */
class CreatePostDocumentQueryTest extends \PHPUnit_Framework_TestCase {

    /**
     * @var CreatePostDocumentQuery
     */
    protected $createPostDocumentQuery;

    private $filename = 'noise.png';
    private $postIntrahash = 'e645f73921b98b1c6b0e17fe617b74b2';

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

        global $ACCESSOR_BASICAUTH;

        $deletePostDocumentQuery = new Queries\Delete\DeletePostDocumentQuery(
                TEST_USER_ID, $this->postIntrahash, $this->filename);

        // Check statuscode.
        $statusCode = $deletePostDocumentQuery->execute($ACCESSOR_BASICAUTH->getClient())->getStatusCode();
        $this->assertEquals('200', $statusCode);
    }

    /**
     * @dataProvider executeProvider
     */
    public function testExecute($accessor, $filepath, $resourceHash, $username) {

        $this->createPostDocumentQuery = new CreatePostDocumentQuery($filepath, $resourceHash, $username);

        // Check status code.
        $statusCode = $this->createPostDocumentQuery->execute($accessor->getClient())->getStatusCode();
        $this->assertEquals('201', $statusCode);

        // Is executed flag set?
        $this->assertTrue($this->createPostDocumentQuery->isExecuted());
    }

    public function executeProvider() {

        global $ACCESSOR_OAUTH, $ACCESSOR_BASICAUTH;

        return array(
          array($ACCESSOR_BASICAUTH, PROJECT_HOME.'/data/user_exports/'
                .$this->filename, $this->postIntrahash, TEST_USER_ID),
          array($ACCESSOR_OAUTH, PROJECT_HOME.'/data/user_exports/'
                .$this->filename, $this->postIntrahash, TEST_USER_ID)
        );
    }
}
