<?php

/*
 *  restclient-php is a full-featured REST client for PUMA and/or
 *  BibSonomy.
 *
 *  Copyright (C) 2015
 *
 *  Knowledge & Data Engineering Group,
 *  University of Kassel, Germany
 *  http://www.kde.cs.uni-kassel.de/
 *
 *  HothoData GmbH, Germany
 *  http://www.academic-puma.de
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

namespace AcademicPuma\RestClient\Renderer;


/**
 * Short description
 *
 * @since 09.07.15
 * @author Sebastian Böttger / boettger@cs.uni-kassel.de
 */
class BibtexModelRendererTest extends \PHPUnit_Framework_TestCase {


    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {

    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {

    }

    public function testSerializeResource() {
        $bibtexRenderer = new BibtexModelRenderer(true);

        $postsObject = TestHelper::loadObject('bibtex.object');

        $actual = $bibtexRenderer->render($postsObject);
        $expected = TestHelper::loadBibTeX('bibtex.bib');
        print_r($actual);
        echo "\n";
        $this->assertStringStartsWith('@', $actual);
        $this->assertStringEndsWith("}\n", $actual);

        $this->assertEquals($expected, $actual);
    }

    public function testSerializePosts() {
        $postsObject = TestHelper::loadObject('posts.object');


        echo "without misc fields\n";
        $bibtexRenderer = new BibtexModelRenderer();
        $actual = $bibtexRenderer->render($postsObject);
        print_r($actual);
        echo "\n";
        $this->assertStringStartsWith('@', $actual);
        $this->assertStringEndsWith("}\n", $actual);


        echo "including misc fields\n";
        $bibtexRenderer = new BibtexModelRenderer(true);
        $actual = $bibtexRenderer->render($postsObject);
        print_r($actual);
        echo "\n";
        $this->assertStringStartsWith('@', $actual);
        $this->assertStringEndsWith("}\n", $actual);
    }
}
