<?php

namespace AcademicPuma\RestClient\Renderer;

use AcademicPuma\RestClient\Model;
use AcademicPuma\RestClient\Util;
/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-04-01 at 13:57:45.
 */
class XMLModelUnserializerTest extends \PHPUnit_Framework_TestCase {

    protected $deserializer;
    protected $xmlString1;
    protected $xmlString2;

    /**
     * Sets up the fixture, for example, opens a network connection.
     * This method is called before a test is executed.
     */
    protected function setUp() {
        
        $this->xmlString1 = '';
        $this->xmlString2 = '';
        
    }

    /**
     * Tears down the fixture, for example, closes a network connection.
     * This method is called after a test is executed.
     */
    protected function tearDown() {
        
    }

    /**
     * @covers AcademicPuma\RestClient\renderer\XMLModelUnserializer::convertToModel
     * @todo   Implement testConvertToModel().
     */
    public function testConvertToModel() {
        
        ####### TEST post #######
        $xmlString1 = TestHelper::loadXML('post.xml');
        $post = (new XMLModelUnserializer($xmlString1))->convertToModel();
        $this->assertTrue($post instanceof Model\Post);
        
        ####### TEST posts #######
        $xmlString2 = TestHelper::loadXML('posts.xml');
        $posts = (new XMLModelUnserializer($xmlString2))->convertToModel();
        
        $this->assertTrue($posts instanceof Model\Posts);
        
        foreach($posts as $post) {
            $this->assertTrue($post instanceof Model\Post);
            
            $this->assertNotEmpty($post->getUser()->getName());
            $this->assertTrue(count($post->getTag()) > 0);
        }
        
        ####### TEST group #######
        $xmlString3 = TestHelper::loadXML('group.xml');
        $group = (new XMLModelUnserializer($xmlString3))->convertToModel();
        
        $this->assertEquals($group->getName(), 'seminar');
        
        ####### TEST tags #######
        $xmlString4 = TestHelper::loadXML('tags.xml');
        $tags = (new XMLModelUnserializer($xmlString4))->convertToModel();
        
        $this->assertTrue($tags instanceof Model\Tags);
        $this->assertTrue($tags instanceof Util\Collection\ArrayList);
        $this->assertTrue(count($tags) > 0);
        foreach($tags as $tag) {
            $this->assertTrue($tag instanceof Model\Tag);
            $this->assertNotEmpty($tag->getName());
        }
        
        ####### TEST user #######
        $xmlString5 = TestHelper::loadXML('user.xml');
        $user = (new XMLModelUnserializer($xmlString5))->convertToModel();
        
        $this->assertEquals($user->getName(), 'mustermann');
        
        ####### TEST users #######
        $xmlString6 = TestHelper::loadXML('users.xml');
        $users = (new XMLModelUnserializer($xmlString6))->convertToModel();
        
        $this->assertTrue($users instanceof Model\Users);
        $this->assertTrue($users instanceof Util\Collection\ArrayList);
        $this->assertTrue(count($users) > 0);
        foreach($users as $user) {
            $this->assertTrue($user instanceof Model\User);
            $this->assertNotEmpty($user->getName());
        }
        
    }
}
