UPDATE `tx_extbibsonomycsl_domain_model_citationstylesheet` SET `xml_source`='<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<style xmlns=\"http://purl.org/net/xbiblio/csl\" class=\"in-text\" version=\"1.0\" demote-non-dropping-particle=\"sort-only\" default-locale=\"en-US\">\n  <info>\n    <title>BibSonomy – The BibSonomy default CSL style</title>\n    <id>http://www.bibsonomy.org/styles/everyAware.csl</id>\n    <link href=\"http://www.bibsonomy.org/styles/everyAware.csl\" rel=\"self\"/>\n    <author>\n      <name>Sebastian Böttger</name>\n      <email>boettger@cs.uni-kassel.de</email>\n    </author>\n    <author>\n      <name>Andreas Hotho</name>\n      <email>hotho@cs.uni-kassel.de</email>\n    </author>\n    <category citation-format=\"author-date\"/>\n    <updated>2014-03-03T14:18:10+00:00</updated>\n    <rights license=\"http://creativecommons.org/licenses/by-sa/3.0/\">This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 License</rights>\n  </info>\n  <macro name=\"container-contributors\">\n    <choose>\n      <if type=\"chapter paper-conference\" match=\"any\">\n        <names variable=\"editor translator\" delimiter=\", \" suffix=\", \">\n          <name initialize-with=\". \"/>\n          <label form=\"short\" prefix=\" (\" suffix=\".)\" strip-periods=\"true\"/>\n        </names>\n      </if>\n    </choose>\n  </macro>\n  <macro name=\"secondary-contributors\">\n    <choose>\n      <if type=\"chapter paper-conference thesis\" match=\"none\">\n        <names variable=\"editor translator\" delimiter=\", \" prefix=\" (\" suffix=\")\">\n          <name delimiter=\"; \" delimiter-precedes-last=\"always\" initialize-with=\". \"/>\n          <label form=\"short\" prefix=\", \" suffix=\".\" strip-periods=\"true\"/>\n        </names>\n      </if>\n    </choose>\n    <choose>\n      <if type=\"thesis\" match=\"any\">\n        <group delimiter=\", \" suffix=\".\">\n          <text value=\"PhD thesis\"/>\n          <text variable=\"publisher\" form=\"long\"/>\n          <text variable=\"publisher-place\" form=\"long\"/>\n        </group>\n      </if>\n    </choose>\n  </macro>\n  <macro name=\"author\">\n    <names variable=\"author\">\n      <name name-as-sort-order=\"all\" sort-separator=\", \" delimiter=\"; \" delimiter-precedes-last=\"always\">\n        <name-part name=\"family\"/>\n        <name-part name=\"given\"/>\n      </name>\n      <substitute>\n        <names variable=\"editor\"/>\n        <names variable=\"translator\"/>\n      </substitute>\n    </names>\n  </macro>\n  <macro name=\"author-short\">\n    <names variable=\"author\">\n      <name form=\"short\" delimiter=\", \" initialize-with=\". \"/>\n      <substitute>\n        <names variable=\"editor\"/>\n        <names variable=\"translator\"/>\n        <choose>\n          <if type=\"bill book graphic legal_case legislation motion_picture report song\" match=\"any\">\n            <text variable=\"title\" form=\"short\" font-style=\"italic\"/>\n          </if>\n          <else>\n            <text variable=\"title\" form=\"short\"/>\n          </else>\n        </choose>\n      </substitute>\n    </names>\n  </macro>\n  <macro name=\"access\">\n    <choose>\n      <if type=\"thesis\">\n        <choose>\n          <if variable=\"archive\" match=\"any\">\n            <group>\n              <text term=\"retrieved\" text-case=\"capitalize-first\" suffix=\" \"/>\n              <text term=\"from\" suffix=\" \"/>\n              <text variable=\"archive\" suffix=\".\"/>\n              <text variable=\"archive_location\" prefix=\" (\" suffix=\")\"/>\n            </group>\n          </if>\n          <else>\n            <group>\n              <text term=\"retrieved\" text-case=\"capitalize-first\" suffix=\" \"/>\n              <text term=\"from\" suffix=\" \"/>\n              <text variable=\"URL\"/>\n            </group>\n          </else>\n        </choose>\n      </if>\n      <else>\n        <choose>\n          <if variable=\"DOI\">\n            <text variable=\"DOI\" prefix=\"doi:\"/>\n          </if>\n          <else>\n            <choose>\n              <if type=\"webpage\">\n                <group>\n                  <text term=\"retrieved\" text-case=\"capitalize-first\" suffix=\" \"/>\n                  <date variable=\"accessed\" suffix=\", \">\n                    <date-part name=\"month\" suffix=\" \"/>\n                    <date-part name=\"day\" suffix=\", \"/>\n                    <date-part name=\"year\"/>\n                  </date>\n                  <group>\n                    <text term=\"from\" suffix=\" \"/>\n                    <text variable=\"URL\"/>\n                  </group>\n                </group>\n              </if>\n              <else>\n                <group>\n                  <text term=\"retrieved\" text-case=\"capitalize-first\" suffix=\" \"/>\n                  <text term=\"from\" suffix=\" \"/>\n                  <text variable=\"URL\"/>\n                </group>\n              </else>\n            </choose>\n          </else>\n        </choose>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"title\">\n    <choose>\n      <if type=\"report thesis\" match=\"any\">\n        <text variable=\"title\" font-style=\"italic\"/>\n        <group prefix=\". Technical Report (\" suffix=\"), \">\n          <text variable=\"genre\"/>\n          <text variable=\"number\" form=\"long\"/>\n        </group>\n      </if>\n      <else-if type=\"bill book graphic legal_case legislation manuscript motion_picture report song speech\" match=\"any\">\n        <text variable=\"title\" font-style=\"italic\"/>\n      </else-if>\n      <else>\n        <text variable=\"title\" form=\"long\" suffix=\".\"/>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"publisher\">\n    <choose>\n      <if type=\"report thesis\" match=\"any\">\n        <group delimiter=\", \" suffix=\".\">\n          <text variable=\"publisher\" form=\"long\"/>\n          <text variable=\"publisher-place\"/>\n        </group>\n      </if>\n      <else>\n        <choose>\n          <if variable=\"event\" match=\"none\">\n            <text variable=\"genre\" suffix=\", \"/>\n          </if>\n        </choose>\n        <group delimiter=\": \">\n          <text variable=\"publisher-place\"/>\n          <text variable=\"publisher\"/>\n        </group>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"event\">\n    <choose>\n      <if variable=\"event\">\n        <choose>\n          <if variable=\"genre\" match=\"none\">\n            <text variable=\"event\" form=\"long\" suffix=\". \"/>\n          </if>\n          <else>\n            <group delimiter=\" \" suffix=\". \">\n              <text variable=\"genre\" text-case=\"capitalize-first\"/>\n              <text variable=\"event\"/>\n            </group>\n          </else>\n        </choose>\n      </if>\n    </choose>\n  </macro>\n  <macro name=\"issued\">\n    <choose>\n      <if variable=\"issued\">\n        <group prefix=\" (\" suffix=\").\">\n          <date variable=\"issued\">\n            <date-part name=\"year\"/>\n          </date>\n          <choose>\n            <if type=\"article-journal bill book chapter graphic legal_case legislation motion_picture paper-conference report song\" match=\"none\">\n              <date variable=\"issued\">\n                <date-part prefix=\", \" name=\"month\"/>\n                <date-part prefix=\" \" name=\"day\"/>\n              </date>\n            </if>\n          </choose>\n        </group>\n      </if>\n      <else>\n        <text prefix=\" (\" term=\"no date\" suffix=\").\" form=\"short\"/>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"issued-year\">\n    <choose>\n      <if variable=\"issued\">\n        <date variable=\"issued\">\n          <date-part name=\"year\"/>\n        </date>\n      </if>\n      <else>\n        <text term=\"no date\" form=\"short\"/>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"edition\">\n    <choose>\n      <if is-numeric=\"edition\">\n        <group delimiter=\" \">\n          <number variable=\"edition\" form=\"ordinal\"/>\n          <text term=\"edition\" form=\"short\" plural=\"false\" strip-periods=\"true\"/>\n        </group>\n      </if>\n      <else>\n        <text variable=\"edition\" suffix=\", \"/>\n      </else>\n    </choose>\n  </macro>\n  <macro name=\"locators\">\n    <choose>\n      <if type=\"article-journal article-magazine article-newspaper\" match=\"any\">\n        <group delimiter=\"\" prefix=\" \">\n          <text variable=\"volume\" form=\"long\" font-weight=\"bold\"/>\n          <text variable=\"issue\" form=\"long\" prefix=\"(\" suffix=\")\"/>\n        </group>\n      </if>\n      <else-if type=\"bill book chapter graphic legal_case legislation motion_picture paper-conference report song\" match=\"any\">\n        <group prefix=\" (\" suffix=\")\" delimiter=\", \">\n          <text macro=\"edition\"/>\n          <group>\n            <text term=\"volume\" form=\"short\" plural=\"true\" text-case=\"capitalize-first\" suffix=\". \" strip-periods=\"true\"/>\n            <number variable=\"number-of-volumes\" form=\"numeric\" prefix=\"1-\"/>\n          </group>\n          <group>\n            <text term=\"volume\" form=\"short\" text-case=\"capitalize-first\" suffix=\". \" strip-periods=\"true\"/>\n            <number variable=\"volume\" form=\"numeric\"/>\n          </group>\n        </group>\n      </else-if>\n    </choose>\n  </macro>\n  <macro name=\"citation-locator\">\n    <group>\n      <label variable=\"locator\" form=\"short\"/>\n      <text variable=\"locator\" prefix=\" \"/>\n    </group>\n  </macro>\n  <macro name=\"page\">\n    <choose>\n      <if match=\"any\" variable=\"page\">\n        <label variable=\"page\" form=\"short\" prefix=\", \" suffix=\" \"/>\n        <text variable=\"page\" form=\"long\"/>\n      </if>\n    </choose>\n  </macro>\n  <citation et-al-min=\"3\" et-al-use-first=\"1\" disambiguate-add-year-suffix=\"true\" disambiguate-add-names=\"true\" disambiguate-add-givenname=\"true\" givenname-disambiguation-rule=\"by-cite\" collapse=\"year\">\n    <sort>\n      <key macro=\"author\"/>\n      <key macro=\"issued-year\"/>\n      <key variable=\"page\"/>\n    </sort>\n    <layout prefix=\"(\" suffix=\")\" delimiter=\"; \">\n      <group delimiter=\"\">\n        <text macro=\"author-short\"/>\n        <text macro=\"issued-year\" prefix=\" \"/>\n        <text macro=\"citation-locator\"/>\n      </group>\n    </layout>\n  </citation>\n  <bibliography entry-spacing=\"1\" line-spacing=\"1\" hanging-indent=\"false\">\n    <sort>\n      <key macro=\"author\"/>\n      <key macro=\"issued-year\" sort=\"ascending\"/>\n    </sort>\n    <layout>\n      <group>\n        <group delimiter=\" \">\n          <text macro=\"title\"/>\n          <text macro=\"author\" suffix=\" \"/>\n          <group delimiter=\", \">\n            <group prefix=\"in \">\n              <choose>\n              <if type=\"chapter article-magazine article-newspaper article-journal entry-encyclopedia entry\" match=\"any\">\n              tainer-title\" font-style=\"italic\"/>\n              </if>\n                <else-if type=\"book paper-conference\" match=\"any\">\n                  <text variable=\"collection-title\" font-style=\"italic\"/>\n                </else-if>\n              </choose>\n            </group>\n            <text macro=\"container-contributors\"/>\n            <text macro=\"secondary-contributors\"/>\n          </group>\n        </group>\n        <text macro=\"issued\" suffix=\" \"/>\n        <text macro=\"locators\" suffix=\" \"/>\n        <group delimiter=\", \">\n          <text macro=\"event\"/>\n        </group>\n        <text variable=\"page\" form=\"long\" prefix=\" \" suffix=\". \"/>\n        <choose>\n          <if type=\"book\" match=\"any\">\n            <group delimiter=\", \" suffix=\".\">\n              <text variable=\"publisher\" form=\"long\"/>\n              <text variable=\"publisher-place\" form=\"long\"/>\n            </group>\n          </if>\n        </choose>\n      </group>\n    </layout>\n  </bibliography>\n</style>\n' WHERE `uid`=1;